clear all
close all
global RBFtype;  % type of RBF see frbf.m
global RBFpar;   % parameter of RBF, see frbf.m
global RBFscale; % scale of RBF, see frbf.m
%
% RBFtype='g';  % basis function Gauss kernel
% RBFscale=1;   
% RBFpar=0;

%
% RBFtype='g';  % basis function multiquadric kernel
% RBFscale=1;   
% RBFpar=1; % only INVERSE multiquadrics are pos.def. 
%
RBFtype='w'; % basis function Wendland kernel
RBFscale=2;  % scale for Wendland must be larger  
RBFpar=1; 
%
% -----------------------data sites-----------------------------
he=.02;   % h for evaluation grid
[dsites, ind, xee, yee, xe, ye]=cutcircle(he); % generates points
% fval=(dsites(:,1).^2+dsites(:,2).^2).^3;
% fval=(abs(dsites(:,1)-dsites(:,2)));
fval=(max(0,(dsites(:,1)-dsites(:,2)))).^3;
% fval=peaks(3*dsites(:,1),3*dsites(:,2))
% fval=peaks(dsites(:,1),dsites(:,2))
fvals=fval;
Np=length(xee(ind)) % number of points for evaluation
%
% Now the greedy Newton-based method for getting points
maxN=100;  % Maximal number of data sites used
Ptol=1.e-6; % tolerance for residual
% Here is a FGreedy program.
plot(dsites(:,1),dsites(:,2),'.')
valfull=zeros(length(xe(:)),1);
v=zeros(Np,maxN);
ip=zeros(maxN,1);
sk=zeros(maxN,1);
z=frbf(0.0,0)*ones(Np,1);

[zm izm]=max(abs(fval))
iter=1;
sk(iter,1)=fval(izm)/sqrt(z(izm,1));
ip(iter,1)=izm;
pw=[zm];
u=kermat(dsites,dsites(izm,:));
v(:,iter)=u/sqrt(z(izm,1));
w=v(:,iter).^2;
figure
valfull(ind)=fvals;
surf(xe,ye,reshape(valfull,size(xe))); % or surf or surfc 

for iter=2:maxN
    fval=fval-sk(iter-1,1)*v(:,iter-1);
    figure
    valfull(ind)=fval;
    surf(xe,ye,reshape(valfull,size(xe))); % or surf or surfc 
    
    [zm izm]=max(abs(fval))
    if zm<Ptol
        iter=iter-1;
        break;
    end
    pw=[pw zm];
    y=v(izm,1:iter)';
    skl=fvals(izm)-(sk(1:iter-1,1)')*y(1:iter-1);
    u=kermat(dsites,dsites(izm,:))-v(:,1:iter)*y;
    v(:,iter)=u/sqrt((z(izm,1)-w(izm,1)));
    sk(iter,1)=skl/sqrt((z(izm,1)-w(izm,1)));
    w=w+v(:,iter).^2;
    ip(iter,1)=izm;
end
figure
semilogy(pw)
figure
% plot(dsites(:,1),dsites(:,2),'b.')
% hold on
plot(dsites(ip(1:iter,1),1),dsites(ip(1:iter,1),2),'ro')
axis equal
axis([-1 1 -1 1])



end


